package form;

import form.data.*;
import form.comp.*;
import form.edit.*;
import java.awt.* ;
import java.awt.event.* ;
import java.io.*;
import java.util.*;
import java.net.*;

public class FormActionListener implements FormListener{

   private Data data = null;
   private Viewer viewer = null;
   private PropertySheet propSheet = null;

	private Component selected = null;

	public void setData(Data dat){
		data = dat;
	}

   public FormActionListener (Viewer v){
	viewer = v;
	propSheet = new PropertySheet(50,300);
   }
	

  public void mouseClicked(MouseEvent e) {

	Component c = e.getComponent();
	//add and exit if parent not FormPanel
	FormPanel p = ((FormPanel)c.getParent());
	p.doLayout();

	if (selected == null){
		c.setBackground(Color.blue);
		selected    = ((Component)c);
		propSheet.setTarget(selected);
	}
	else if (selected == c){
		selected.setBackground(Color.lightGray);
		selected = null;
		return;
	}
	//selected != null 
	//will move new comp before (may change) old comp
	else {
		p.remove(selected);
		int location = p.getIndex(c);
		selected.setBackground(Color.lightGray);
		p.add(selected,location);
	    p.validate();
		selected = null;
	}
	p.doLayout();

  }

  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {
	if (e.isPopupTrigger() ){
		System.out.println("popup event");
	}
	}
  public void mouseReleased(MouseEvent e) {}
  public void actionPerformed (ActionEvent e) {
		String command = e.getActionCommand();
		Button b = ((Button)e.getSource());
		String params = b.getActionCommand();
		if (command.startsWith("panel")){
			System.out.println("Params for button: "+params);
			viewer.setViewable(params);
			//d.setVisible(true);
			return;
		}
		else if (command.startsWith("submit")){
			System.out.println(data.getText());
			System.exit(1);
        }
		else if (command.startsWith("dismiss")){
			((Window)b.getParent().getParent()).dispose();
	//		FormDialog d = data.getFormDialog(params);
	//		d.dispose();
	//	window.dispose();
 //       System.exit(1);
		}
  }

}
